#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Mar 13 17:07:01 2024

TODO: Treat correctly the case of the Pop III stars and the different IMF possibilities

@author: darwin
"""
import numpy as np
from pNbody import *
from pNbody import Nbody
import argparse
from MaDarwinR.scripts_utils import RawTextArgumentDefaultsHelpFormatter
from MaDarwinR.analysis_functions import get_expected_imf_masses
import os


# %%
def select_stars(nb_star, star_type, popIII_threshold=-5):
    if star_type == "all":
        nb_select = nb_star
    elif star_type == "PopII":
        is_PopII = (nb_star.Fe() >= popIII_threshold)
        nb_select =  nb_star.selectc(is_PopII)
    elif star_type == "PopIII":
        is_PopIII = (nb_star.Fe() < popIII_threshold)
        nb_select = nb_star.selectc(is_PopIII)
    else:
        raise ValueError("Star type {} not yet implemented".format(star_type))
    return nb_select

# %%
def parse_option():
    description = """"
Verify that the IMF generated by the sinks of the inputs agrees with the expected IMF values.
    """
    epilog = """
Examples:
--------
madr_verify_imf_sampling.py  h177l11_adaptive_jed/snap/* --minimal_discrete_mass=8 --stellar_particle_mass=95.0
"""
    parser = argparse.ArgumentParser(description=description, epilog=epilog,
                                     formatter_class=RawTextArgumentDefaultsHelpFormatter)

    parser.add_argument("files",
                        nargs="+",
                        type=str,
                        help="File name(s).")

    parser.add_argument("-t",
                        action="store",
                        type=str,
                        dest="ftype",
                        default='swift',
                        help="Type of the output file")

    # Particle parameters
    parser.add_argument("--minimal_discrete_mass",
                        action="store",
                        type=float,
                        default=8,
                        help="Mass of the stellar particle representing the low mass stars, in solar mass")

    # Particle parameters
    parser.add_argument("--stellar_particle_mass",
                        action="store",
                        type=float,
                        default=20,
                        help="Mass of the stellar particle representing the low mass stars, in solar mass")

    # Particle parameters
    parser.add_argument("--imf_min_mass",
                        action="store",
                        type=float,
                        default=0.05,
                        help="Minimal mass of the IMF. In our models, it is 0.05 for Pop II and 13 for pop III.")

    # Particle parameters
    parser.add_argument("--imf_max_mass",
                        action="store",
                        type=float,
                        default=30,
                        help="Max mass of the IMF. In our models, it is 30 for Pop II and 300XXX for pop III.")

    parser.add_argument("--select_population",
                        action="store",
                        type=str,
                        choices=["all", "PopII", "PopIII"],
                        default="all",
                        help="Select a star population.")

    parser.add_argument("--popIII_threshold",
                        action="store",
                        type=float,
                        default=-5,
                        help="Threshold value to disthinguish Pop III stars from Pop II (Pop III: Z < threshold).")


    parser.parse_args()
    args = parser.parse_args()
    files = args.files

    for f in files:
        if not os.path.exists(f):
            raise FileNotFoundError("You need to provide one file")

    return args, files

# %% Main


if __name__ == "__main__":
    # Parse the input
    opt, files = parse_option()
    select_population = opt.select_population
    popIII_threshold = opt.popIII_threshold
    imf_min_mass = opt.imf_min_mass
    imf_max_mass = opt.imf_max_mass

    print("\n-------------------------------------")
    print("Welcome to IMF  verification script !\n")

    minimal_discrete_mass = opt.minimal_discrete_mass
    m_star_part_continuous = opt.stellar_particle_mass

    for filename in files:
        # Select the object
        print("Loading the data for file '{}'...".format(filename))
        nb_star = Nbody(p_name=filename, ptypes=[4])
        nb_star = select_stars(nb_star, select_population, popIII_threshold)

        # Do not continue if you do not find stars.
        if nb_star.npart[4] == 0:
            print("No stars found in this file. Continue to the next file...\n")
            continue

        # Theoretical Mass of the continuous part and of the discrete part
        M_c_th, M_d_th = get_expected_imf_masses(M_star_continuous=m_star_part_continuous, M_cont_max=minimal_discrete_mass,
                                                 imf_Mmax=imf_max_mass, imf_Mmin=imf_min_mass, imf_a_coeff=[0.7, -0.8, -1.7, -1.3], imf_m_s=[0.08, 0.5, 1.0])
        ratio_mc_md_th = M_c_th/M_d_th

        # Find the mass of the discrete and continuous part of the IMF
        is_IMF_continuous_part = np.equal(nb_star.sp_type, 1)
        mass_s_init = nb_star.InitialMass(units="Msol")
        M_c = np.sum(mass_s_init[np.argwhere(is_IMF_continuous_part)])
        M_d = np.sum(mass_s_init[np.argwhere(
            np.logical_not(is_IMF_continuous_part))])
        ratio_mc_md = M_c / M_d

        print("Expected ratio M_c/M_d = {:e}".format(ratio_mc_md))
        print("Effective ratio M_c/M_d = {:e}\n".format(ratio_mc_md_th))

    print("END-------------------------------------")
